import { Cell } from './cell';
import type { Track } from './cell';
declare type Executor = (signal: AbortSignal) => Promise<any>;
export declare class CellSuspended {
    readonly executor: Executor;
    constructor(executor: Executor);
}
export declare type SuspendedCellOptions<T, F> = {
    fallback: F;
    initial: T;
    comparator: (a: T, b: T) => boolean;
};
declare type SuspendedTrack = Track & {
    suspend<T>(cell: SuspendedCell<T, any>): T;
};
export declare class SuspendedCell<T, F> extends Cell<T | F> {
    [Symbol.toStringTag]: string;
}
export declare function suspended<T, F = undefined>(expr: ($: SuspendedTrack) => T, options?: Partial<SuspendedCellOptions<T, F>>): SuspendedCell<T, F>;
export {};
