import { Cleanable, TeardownLogic } from './types';
export declare class EventStream<T> {
    private producer;
    constructor(producer: (next: (value: T) => void) => Cleanable);
    private disposeProducer;
    private head;
    private tail;
    private propagating;
    private __internal_subscribe;
    private next;
    listen(handler: (value: T) => Cleanable): TeardownLogic;
    transform<R>(transformFn: (value: T) => R): EventStream<R>;
    filter(filterFn: (value: T) => boolean): EventStream<T>;
    static create<T, S = T>(transformer?: (value: S) => T): [EventStream<T>, (payload: S) => void];
}
export declare function stream<T = any, S = T>(transformer?: (value: S) => T): [EventStream<T>, (payload: S) => void];
declare type ExtractEventStream<T> = {
    [P in keyof T]: T[P] extends EventStream<infer C> ? C : unknown;
};
export declare function merged<A extends Array<EventStream<any>>>(array: A): EventStream<ExtractEventStream<A>[number]>;
export {};
